$NOFLOATCALLS
$STORAGE:2
$DEBUG
C---PROGRAM TRAVEL CALCULATES TRAVEL TIME THOUGH AUGUSTINE VELOCITY
C---STRUCTURE FOR 5 STATIONS TWO OF WHICH HAVE LATERAL VELOCITY
C---DISCONTINUITIES BETWEEN GRID POINT AND STATION A2V,AU5
C---PROGRAM LAST MODIFIED BY D. LALLA 10/13/87--------------------
C
      DIMENSION XA(169),YA(169),A2(169),A5(169)
      DIMENSION DELTA1(169),DELTA2(169),DELTA3(169),DELTA4(169)
      DIMENSION T1(169),T2(169),T3(169),T4(169),T5(169)
      DIMENSION DELTA5(169)
      COMMON/THICK/TH1,TH2,TH3
C-----------COMPUTER DEPENDENT FILE I/0---------------------------
      OPEN(8,FILE='TIME.DAT',STATUS='NEW',FORM='FORMATTED')
C-----------------------------------------------------------------
C---------------------PROGRAM CONSTANTS--------------------------
C---TOP SIN OF MAXIMIUM ANGLE ALLOWED
C---KR=TOTAL NUMBER OF GRID POINTS
C---SD2,5=DISTANCE**2 FROM ORIGIN TO STATION 2,5
C---ER=MIN DIFFERENCE IN SIN OF ANGLE OF RAY CHOSEN TO HIT STATION
      TOP=.99999
      KR=169
      ER=.00001
C---LAYER VELOCITIES V?-----------------------------------------------
C---V1 BASEMENT VELOCITY
C---V2 INTERIOR RING 0 -TH3 KM
C---V3 OUTER RING VELOCITY
C---V4 VELOCITY BY STA3
C---V5 PYROCLASTIC VELOCITY
C---V6 VELOCITY BETWEEN TH2 KM. AND SUMMIT
      V1=5.0
      V2=3.4
      V3=2.6
      V4=2.1
      V5=1.2
      V6=2.3
C---MODEL LAYER THICKNESS---------------------------------------------
      TH1=.135
      TH2=.865
      TH3=.9
C---STATION ELEVATION ABOVE SEA LEVEL--------------------------------
C---STATION AUP or AUL or AU1
      EL1=0.360
C---STATION AUE or A2V
      EL2=.168
C---STATION AUI OR AU3
      EL3=.360
C---STATION AUH OR AU4
      EL4=0.90
C---STATION AUL or AU1
      EL5=.276
C----------------------------------------------------------------
C----------STATION COORDINATES-----------------------------------
C STATION 2,5 MUST LIE IN OUTER RING SECTOR OF LOW VELOCITY
C STATION 1,4 MUST LIE IN INNER RING
C STATION 3 MUST LIE IN OUTER RING SECTOR OF HIGH VELOCITY
C STATION 1 = AUL, 2 = AUE, 3 = AUI, 4 = AUH, 5 = AUW
      XSTA1=-2.321
      YSTA1=.-0.244
      XSTA2=-1.181
      YSTA2=3.050
      XSTA3=2.90
      YSTA3=0.0
      XSTA4=-.251
      YSTA4=-.905
      XSTA5=-0.937
      YSTA5=-2.55
C---------------------------------------------------------------------
      SD2=STA(XSTA2,YSTA2,0.0,0.0)
      SD2=SD2*SD2
      SD5=STA(XSTA5,YSTA5,0.0,0.0)
      SD5=SD5*SD5
C---------------------------------------------------------------------
C-------COMPUTATION OF STATION UNIT THICKNESS STATION CORRECTIONS
C---CODE STV1V2 REFRACTOR V1 OVERBURDEN V2
C---REFRACTOR V1----------------
      STV2V1=SCOR(V2,V1)
      STV3V1=SCOR(V3,V1)
      STV4V1=SCOR(V4,V1)
      STV5V1=SCOR(V5,V1)
      STV6V1=SCOR(V6,V1)
C---------------------------------------------------------------------
C---REFRACTOR V2----------------
      STV3V2=SCOR(V3,V2)
      STV4V2=SCOR(V4,V2)
      STV5V2=SCOR(V5,V2)
      STV6V2=SCOR(V6,V2)
C---------------------------------------------------------------------
C---REFRACTOR V3----------------
      STV4V3=SCOR(V4,V3)
      STV5V3=SCOR(V5,V3)
C---------------------------------------------------------------------
C---------------------------------------------------------------------
C ZM=THE DEPTH OF THE LAYER .25 ABOVE THE
C STARTING POINT OF THE TRAVEL TIME CALCULATIONS.
C THE CARTESIAN COORDINATE SYSTEM IN WHICH THE CALCULATIONS
C ARE PERFORMED IS CENTERED ATA LATITUDE OF 59 21.695
C AND LONGITUDE OF 153 25.655. THE CENTER OF THE SYSTEM
C HAS THE COORDINATES OF THE VOLCANO'S SUMMIT.
C Z=0      IS DEFINED AS SEA LEVEL. POSITIVE Z IS UP,
C POSITIVE X IS SOUTH AND POSITIVE Y IS EAST.
C---------------------------------------------------------------------
C------INPUT START POSITION PARAMETERS-------------------
C--------------------------------------------------------------------
      WRITE(*,37)
   37 FORMAT(1X,'INPUT START DEPTH +.25 KM.=  ')
      READ(*,22) ZM
   22 FORMAT(F8.2)
      WRITE(*,36)
   36 FORMAT(1X,'INPUT NUMBER OF LAYERS=  ')
      READ(*,23) JJ
   23 FORMAT(I2)
C--------------------------------------------------------------------
C THE CURRENT VERSION OF THE PROGRAM IS SET UP TO CALCULATE
C A GRID WITH POINT SPACING OF .25KM.. THE GRIDS N.W.
C CORNOR IS LOCATED AT XA(1),YA(1).
C THIS SECTION GENERATES THE GRID.
C M=# OF GRID POINTS IN THE Y DIRECTION .
C THE LENGTH OF THE GRID IN THE X DIRRCTION =(169/M-1.)*.25KM.
C THE LENGTH OF THE GRID IN THE Y DIRECTION =(M-1)*.25KM.
      XA(1)=-1.5
      YA(1)=-1.5
      L=2
      M=13
  300 CONTINUE
      DO 10 I=L,M
      XA(I)=XA(I-1)
      YA(I)=YA(I-1)+.25
   10 CONTINUE
      I=I-1
      IF(I+1.GE.169) GO TO 15
      XA(I+1)=XA(I)+.25
      YA(I+1)=YA(I)-3.0
      L=I+2
      M=M+13
      GO TO 300
   15 CONTINUE
C------------------------------------------------------------
C DELTA1-5 IS THE HORIZONTAL DISTANCE IN KM. BETWEEN A GRID
C POINT AND A STATION.
      DO 48 I=1,169
      DELTA1(I)=STA(XA(I),YA(I),XSTA1,YSTA1)
      DELTA2(I)=STA(XA(I),YA(I),XSTA2,YSTA2)
      DELTA3(I)=STA(XA(I),YA(I),XSTA3,YSTA3)
      DELTA4(I)=STA(XA(I),YA(I),XSTA4,YSTA4)
      DELTA5(I)=STA(XA(I),YA(I),XSTA5,YSTA5)
C-------- DEK IS DISTANCE FROM STATION TO ORIGIN-------------
      DEK=STA(XA(I),YA(I),0.,0.)
C------------------------------------------------------------
C A2(I),A5(I) ARE THE DISTANCE BETWEEN A GRID POINT AND THE
C THE LATERAL DISCONTINUITY.
      A2(I)=QUAD(DELTA2(I),DEK,SD2)
      A5(I)=QUAD(DELTA5(I),DEK,SD5)
   48 CONTINUE
C---------------------------------------------------------------------
C---------------------------------------------------------------------
C---------------------------------------------------------------------
C # OF LAYERS IN THE MODEL =JJ.
C THIS LOOP(666) CALCULATES TRAVEL TIMES LAYER BY LAYER.
C THIS LOOP(30) CALCULATES TRAVEL TIMES FOR LAYER KK.
      DO 666 KK=1,JJ
      ZM=ZM-.25
      IF(ABS(ZM).LT. .001) THEN
      ZM=.001
      ENDIF
      WRITE(*,545) ZM
 545  FORMAT(1X,'CURRENTLY CALCULATING DEPTH=',F6.2)
      DO 30 I=1,169
      Z=ZM
C THE LATERAL DISCONTINUITY LIES BETWEEN SEA LEVEL AND -TH3 KM.
C------DEPTH DECISION  TREE------------------------------------------
      IF(Z.LT.-TH3) GO TO 503
      IF(Z.LE.0. .AND. Z .GE. -TH3) GO TO 500
      IF(Z.LE.TH2.AND.Z .GT.0.) GO TO 501
      IF(Z.LE. 1.0.AND. Z .GT. TH2) GO TO 502
C---------------------------------------------------------------------
C-------------------------Z<-TH3 KM------------------------------------
  503 CONTINUE
C
C BEGIN CALCULATION OF TRAVEL-TIMES TO A2V.
C AU1D,AU2D,AU3D,AU4D,AU5D ARE THE SINE OF THE
C ANGLE A RAY MAKES WITH THE UPWARD VERTICAL
C MEASURED CLOCKWISE, STARTING AT THE GRID POINT
C AND ENDING AT THE STATION. THIS FUNCTION IS USED
C FOR THE CASE OF A RAY TRAVERSING A LATERAL DISCONTINUITY.
      ZL=ABS(Z)-TH3
C STHETA IS THE SINE OF THE ANGLE A RAY MAKES WITH THE UPWARD
C VERTICAL MEASURED CLOCKWISE. THE
C RAY STARTS AT A GRID POINT IN V=V1KM./SEC.
C AND IMPACTS AT THE V2/V1      KM/SEC. BOUNDRY.
      STHETA=A2(I)/SQRT(A2(I)*A2(I)+ZL*ZL)
C THETA1 IS THE SINE OF THE ANGLE FOR THE PRECEDING
C RAY IN THE V3KM./SEC MEDIA IF IT IMPACTS ON THE V3KM./SEC.
C SIDE OF THE VELOCITY BOUNDRY.
      THETA1=(V3/V1)*STHETA
C DEL IS THE HORIZONTAL DISTANCE THE PRECEDING
C RAY TRAVELS TOWARD STATION A2V, MEASURED IN THE DIRECTION
C OF A LINE CONNECTING THE GRID POINT TO THE STATION WITH
C THE ZERO POINT BEING THE INTERSECTION OF THE UPWARD EX-
C TENSION OF THE V2/V3 KM./SEC. BOUNDRY.
C IN THIS CASE THE LATERAL DISCONTINUITY IS MISSED.
  805 FORMAT(1X,'THETA1= ',F10.7,2X,F10.7,2X,F10.5)
      DEL=ANGLE(THETA1,0.,TH3,EL2,0.,0.,V3,V5,0.,0.)
      T2(I)=53.
      TOP=.99999
C IF THE FOLLOWING STATEMENT IS TRUE A HOMOGENOUS PATH
C IS POSSIBLE.
      IF(((DELTA2(I)-A2(I))-DEL).GT.0.) GO TO 506
C---------------Z<-TH3-------------------------------------------------
C----CALCULATE TRAVEL TIME LATERAL DISCON  STATION 2
  518 CONTINUE
C BEGIN CALCULATION FOR TRAVEL-TIMES FOR PATH #3.
      TNG=25.
C TOP2=THETA MAX
      TOP2=STHETA
C BOT2=THETA MINIMUM
      BOT2=BOT(A2(I),ABS(Z),0.)
C TEST TO SEE IF THERE WILL BE A SOLUTION .
      DB=ANGLE2(A2(I),BOT2,DELTA2(I),Z,EL2,V2,V3,V5)
      IF(DB.GT.0.) GO TO 508
      DB=ANGLE2(A2(I),TOP2,DELTA2(I),Z,EL2,V2,V3,V5)
      IF(DB.LT.0.) GO TO 508
      AU2D=SOLN2(1,A2(I),BOT2,TOP2,ER,IENN,DELTA2(I),Z,EL2
     &,V2,V3,V5)
C DELTAN IS HORIZONTAL DISTANCE BETWEEN IMPACT POINT
C OF RAY AT Z=-TH3 AND STATION.
      DELTAN=DELTA2(I)-(ZL)*(AU2D/SQRT(1-AU2D*AU2D))
C XNA=SIN(THETA(K+1))
      XNA=AU2D*(V2/V1)
      DEL=A2(I)-ZL*(AU2D/SQRT(1-AU2D*AU2D))
C TEST TO SEE IF RAY ISIN MODEL.
      TEST=DEL/(XNA/SQRT(1-XNA*XNA))
      IF(TEST.GT.TH3) GO TO 508
      TNG=TIMX(AU2D,ZL,A2(I),V1,V2,V3,V5,TH3,EL2)
C WHICH PATH IS FASTER ?
  778 FORMAT(1X,'INHOM= ',F10.6,2X,F10.3,2X,F10.2,2X,I2)
      IF((TNG-T2(I)).LT.0.) T2(I)=TNG
  508 CONTINUE
C BEGIN CALCULATION OF TRAVEL TIMES TO AU5.
      STHETA=A5(I)/SQRT(A5(I)*A5(I)+ZL*ZL)
      THETA1=(V3/V1)*STHETA
      DEL=ANGLE(THETA1,0.,TH3,EL5,0.,0.,V3,V5,0.,0.)
      T5(I)=53.
      IF(((DELTA5(I)-A5(I))-DEL).GT.0.) GO TO 507
  519 CONTINUE
C BEGIN CALCULATION OF TRAVEL TIMES FOR PATH #3.
      TNG=25.
      TOP2=STHETA
      BOT2=BOT(A5(I),ABS(Z),0.)
C TEST TO SEE IF THERE WILL BE A SOLUTION .
      DB=ANGLE2(A5(I),BOT2,DELTA5(I),Z,EL5,V2,V3,V5)
      IF(DB.GT.0.) GO TO 510
      DB=ANGLE2(A5(I),TOP2,DELTA5(I),Z,EL5,V2,V3,V5)
      IF(DB.LT.0.) GO TO 510
      AU5D=SOLN2(1,A5(I),BOT2,TOP2,ER,IERR,DELTA5(I),Z,EL5
     &,V2,V3,V5)
      DELTAN=DELTA5(I)-ZL*(AU5D/SQRT(1-AU5D*AU5D))
      XNA=AU5D*(V2/V1)
      DEL=A5(I)-ZL*(AU5D/SQRT(1-AU5D*AU5D))
      TEST=DEL/(XNA/SQRT(1.-XNA*XNA))
      IF(TEST.GT.TH3) GO TO 510
      TNG=TIMX(AU5D,ZL,A5(I),V1,V2,V3,V5,TH3,EL5)
      IF((TNG-T5(I)).LT.0.) T5(I)=TNG
C---CALCULATE TRAVEL TIMES FOR STATIONS AU1,AU3,AU4-------------------
C---- FROM GRID POINTS WITHIN THE V1 KM./SEC. LAYER.------------------
  510 CONTINUE
      BOT1=BOT(DELTA1(I),Z,EL1)
      BOT4=BOT(DELTA4(I),Z,EL4)
      BOT3=BOT(DELTA3(I),Z,EL3)
  800 FORMAT(1X,'AU1')
      AU1D=SOLN(1,BOT1,TOP,ER,IERR,DELTA1(I),ZL,TH3,EL1,0.,V1,V2,V3,0.)
  801 FORMAT(1X,'AU3')
      AU3D=SOLN(1,BOT3,TOP,ER,IERR,DELTA3(I),ZL,TH3,EL3,0.,V1
     &,V2,V3,0.)
  802 FORMAT(1X,'AU4')
      AU4D=SOLN(1,BOT4,TOP,ER,IERR,DELTA4(I),ZL,TH3,TH2,TH1,V1
     &,V2,V3,V6)
      T4(I)=TIM(Z,AU4D,V1,V2,V3,V6,TH3,TH2,TH1)
      T1(I)=TIM(Z,AU1D,V1,V2,V3,0.,TH3,EL1,0.)
      T3(I)=TIM(Z,AU3D,V1,V2,V4,0.,TH3,EL3,0.)
C WRITE TRAVEL TIMES CALCULATED FOR THSI GRID POINT.
      GO TO 30
C-- CALCULATE TRAVEL TIMES FOR GRID POINTS 0 -(-TH3)KM DEPTH-----------
C---------------------------------------------------------------------
  500 CONTINUE
C CALULATE MIN ANGLE OF TAKE OFF--
      BOT1=BOT(DELTA1(I),Z,EL1)
      BOT2=BOT(A2(I),Z,EL2)
      BOT3=BOT(DELTA3(I),Z,EL3)
      BOT4=BOT(DELTA4(I),Z,EL4)
      BOT5=BOT(A5(I),Z,EL5)
C----------------------------------------------------------------------
C CALCULATE TAKE OFF ANGLE OF DIRECT WAVE-
      AU1D=SOLN(1,BOT1,TOP,ER,IERR,DELTA1(I),Z,EL1,0.,0.,V2,V3,0.,0.)
      AU3D=SOLN(1,BOT3,TOP,ER,IERR,DELTA3(I),Z,EL3,0.,0.,V2,V4,0.,0.)
      AU4D=SOLN(1,BOT4,TOP,ER,IERR,DELTA4(I),Z,TH2,TH1,0.
     &,V2,V3,V6,0.)
      AU2D=SOLN2(1,A2(I),BOT2,TOP,ER,IERR,DELTA2(I),Z,EL2
     &,V2,V3,V5)
      AU5D=SOLN2(1,A5(I),BOT5,TOP,ER,IERR,DELTA5(I),Z,EL5
     &,V2,V3,V5)
C---------------------------------------------------------------------
C CALCULATE TRAVEL TIMES---
      T1(I)=TIM(Z,AU1D,V2,V3,0.,0.,EL1,0.,0.)
      T2(I)=TIM2(Z,AU2D,DELTA2(I),A2(I),V2,V3,V5,EL2)
      T2R=CRIT(Z,EL2,STV2V1,STV3V1,STV5V1,DELTA2(I),V1)
      T2RH=HCRIT(V1,V2,V3,V5,DELTA2(I),A2(I),EL2,TH3,ABS(Z))
      T2R=AMIN1(T2R,T2RH)
      T2(I)=AMIN1(T2(I),T2R)
      T3(I)=TIM(Z,AU3D,V2,V4,0.,0.,EL3,0.,0.)
      T3R=CRIT(Z,EL3,STV2V1,STV2V1,STV4V1,DELTA3(I),V1)
      T3(I)=AMIN1(T3(I),T3R)
      T4(I)=TIM(Z,AU4D,V2,V3,V6,0.,TH2,TH1,0.)
      T5(I)=TIM2(Z,AU5D,DELTA5(I),A5(I),V2,V3,V5,EL5)
      T5R=CRIT(Z,EL5,STV2V1,STV3V1,STV5V1,DELTA5(I),V1)
      T5RH=HCRIT(V1,V2,V3,V5,DELTA5(I),A5(I),EL5,TH3,ABS(Z))
   64 FORMAT(1X,'STATION 5= ',3(F6.3,2X))
      T5R=AMIN1(T5R,T5RH)
      T5(I)=AMIN1(T5(I),T5R)
C---------------------------------------------------------------------
      GO TO 30
C--------- CALCULATE TRAVEL TIMES FOR GRID POINTS IN------------------
C------------ CONE BETWEEN Z LE TH2 AND GT 0.------------------------
  501 CONTINUE
      T3(I)=ABS(Z)*STV3V2 + EL3*STV4V2 +DELTA3(I)/V2
      T3R=Z*STV3V1 + DELTA3(I)/V1 + EL3*STV4V1 +2.*TH3*STV2V1
      T3(I)=AMIN1(T3R,T3(I))
      T2(I)=STV3V2*Z + A2(I)/V2+ (DELTA2(I)-A2(I))/V3 + EL2*STV5V3
      T2R=Z*STV3V1 + DELTA2(I)/V1 + EL2*STV5V1 +TH3*STV2V1 +TH3*STV3V1
      T2(I)=AMIN1(T2(I),T2R)
      T5(I)=STV3V2*Z + A5(I)/V2+ (DELTA5(I)-A5(I))/V3+ EL5*STV5V3
      T5R=Z*STV3V1 + DELTA5(I)/V1 + EL5*STV5V1 +TH3*STV2V1 +TH3*STV3V1
      T5(I)=AMIN1(T5(I),T5R)
      BOT4=BOT(DELTA4(I),Z,1.)
      AU4D=SOLN(1,BOT4,TOP,ER
     &,IERR,DELTA4(I),(TH2-Z),TH1,0.,0.,V3,V6,0.,0.)
      T4(I)=TIM((TH2-Z),AU4D,V3,V6,0.,0.,TH1,0.,0.)
      TD1=SQRT(DELTA1(I)*DELTA1(I)+(EL1-Z)*(EL1-Z))/V3
      TR1=Z*STV3V2 + EL1*STV3V2 + DELTA1(I)/V2
      T1(I)=AMIN1(TR1,TD1)
      GO TO 30
C-------- CALCULATE TRAVEL TIMES FOR GRID POINTS IN-------------------
C----------- CONE WITH Z LE 1 AND GT TH2-----------------------------
  502 CONTINUE
C-REFRACTION AT Z=0 AND Z=-.9 CONSIDERED STA2,3,5--
      T3(I)=ABS(Z-TH2)*STV6V2 + TH2*STV3V2 +EL3*STV4V2 + DELTA3(I)/V2
      T3R=(Z-TH2)*STV6V1+TH2*STV3V1+TH3*STV2V1+EL3*STV4V1+DELTA3(I)/V1
     & +TH3*STV2V1
      T3(I)=AMIN1(T3(I),T3R)
      T2(I)=(Z-TH2)*STV6V2+A2(I)/V2+(DELTA2(I)-A2(I))/V3 +EL2*STV5V3
     & +TH2*STV3V2
      T2R=(Z-TH2)*STV6V1 + DELTA2(I)/V1 + TH2*STV3V1 +TH3*STV2V1
     & + TH3*STV3V1 +EL2*STV5V1
  488 FORMAT(1X,'S2 T3.4= ',F6.2,2X,'T=',F6.2,2X,F6.2,2X,F6.2,2X,F6.2)
      T2(I)=AMIN1(T2(I),T2R)
      T5(I)=(Z-TH2)*STV6V2+ TH2*STV3V2+A5(I)/V2+(DELTA5(I)-A5(I))/V3
     & + EL5*STV5V2
      T5R=(Z-TH2)*STV6V1 + TH2*STV3V1+ TH3*STV2V1+DELTA5(I)/V1
     & +TH3*STV3V1 +EL5*STV5V1
  489 FORMAT(1X,'S5 T3.4= ',F6.2,2X,'T=',F6.2,2X,F6.2,2X,F6.2,2X,F6.2)
      T5(I)=AMIN1(T5(I),T5R)
C-DIRECT REFRACTED WAVES FOR STA1,4--
      T4(I)=SQRT(DELTA4(I)*DELTA4(I) + (EL4-Z)*(EL4-Z))/V6
      BOT1=BOT(DELTA1(I),Z,EL1)
      AU1D=SOLN(1,BOT1,TOP,ER
     &,IERR,DELTA1(I),.365,(Z-TH2),0.,0.,V3,V6,0.,0.)
      T1(I)=TIM(.365,AU1D,V3,V6,0.,0.,(Z-TH2),0.,0.)
      GO TO 30
C------------------------------------------------------------------
C--- FIND RAY FOR HOMOGENOUS PATH WHICH IMPACTS A2V Z<- TH3 KM.
C--------- CALCULATE TRAVEL TIME.
  506 CONTINUE
  807 FORMAT(1X,'506 HOMOGEN AU2D ',F10.6,2X,F10.4,2X,F10.2,2X,I2)
      AU2D=SOLN(1,STHETA,TOP,ER,IERR,DELTA2(I),ZL,TH3,EL2,0.,V1,
     &V3,V5,0.)
      T2(I)=TIM(Z,AU2D,V1,V3,V5,0.,TH3,EL2,0.)
      GO TO 518
  507 CONTINUE
  809 FORMAT(1X,'AU5 SOLN ',F10.4,2X,F10.4,2X,F10.4)
      AU5D=SOLN(1,STHETA,TOP,ER,IERR,DELTA5(I),ZL,TH3,EL5,0.,V1
     &,V3,V5,0.)
      T5(I)=TIM(Z,AU5D,V1,V3,V5,0.,TH3,EL5,0.)
      GO TO 519
   30 WRITE(8,93) T1(I),T2(I),T3(I),T4(I),T5(I)
C CALCULATE TRAVEL TIMES FOR NEXT GRID POINT IN LAYER.
   35 CONTINUE
   93 FORMAT(F6.3,1X,F6.3,1X,F6.3,1X,F6.3,1X,F6.3)
C GO BACK AND CALCULATE TRAVEL TIMES FOR NEXT LAYER
  666 CONTINUE
      STOP
      END
C---------------------------------------------------------------------
C----BEGIN FUNTIONS--------BEGIN FUNCTIONS--------BEGIN FUNCTIONS-----
C---------------------------------------------------------------------
C---------CALCULATE DISTANCE BETWEEN TWO POINTS-----
C--------------------------------------------------
      FUNCTION STA(X,Y,X1,Y1)
      STA=SQRT((X-X1)*(X-X1) + (Y-Y1)*(Y-Y1))
      RETURN
      END
C---------------------------------------------------------------------
C-------SOLVE THE RAY EQUATION FOR A PATH THROUGH THE LATERAL---------
C--------- DISCONTINUITY BY THE METHOD OF BISECTION.------
C---------------------------------------------------------------------
      FUNCTION SOLN2(IND,A,BOT,TOP,EPS,IERR,DELTA,Z,T2,V1,V2,V3)
      IF(EPS)11,11,21
   11 IERR=-1
      GO TO 5001
   21 X=TOP
      TOPX=X
      MAXIT=500
      TOPY=ANGLE2(A,X,DELTA,Z,T2,V1,V2,V3)
      IF(ABS(TOPY) .LE. .005) GO TO 411
      IF(TOPY)31,411,31
   31 X=BOT
      BOTX1=X
      BOTY=ANGLE2(A,X,DELTA,Z,T2,V1,V2,V3)
      IF(ABS(TOPY) .LE. .005) GO TO 411
      IF(BOTY)41,411,41
   41 IERR=1
      ITER=1
      DX=(TOPX-X)/4.0
   46 X=BOTX1
   51 X=X+2.0*DX
      IF(X-TOPX)61,71,71
   61 IF((ANGLE2(A,X,DELTA,Z,T2,V1,V2,V3))*TOPY)201,411,51
   71 DX=DX/2.0
      GO TO (131,81),IND
   81 IF(DX/(TOPX-BOTX1)-EPS)5001,5001,46
  131 IF(DX-EPS)5001,5001,46
  201 ITER=0
      BOTX=X
      BOTY=ANGLE2(A,X,DELTA,Z,T2,V1,V2,V3)
      IF(ABS(BOTY) .LE. .005) GOTO 411
  211 X=(BOTX+TOPX)/2.0
      ITER=ITER+1
      IF(ITER-MAXIT)221,221,281
  221 GO TO (231,271),IND
  231 IF(TOPX-BOTX-EPS)411,411,241
  241 Y=ANGLE2(A,X,DELTA,Z,T2,V1,V2,V3)
      IF(ABS(Y) .LE. .005) GO TO 411
      IF(BOTY*Y)251,411,261
  251 TOPX=X
      GO TO 211
  261 BOTX=X
      BOTY=Y
      GO TO 211
  271 IF(BOTX*TOPX)241,241,331
  281 GO TO (291,301),IND
  291 IERR=2
      GO TO 421
  301 IF(TOPX*BOTX)306,306,341
  306 IF(TOPX-BOTX-EPS)311,311,321
  311 IERR=3
      GO TO 421
  321 IERR=4
      GO TO 421
  331 IF((TOPX-BOTX)/ABS(X)-EPS)411,411,241
  341 IF((TOPX-BOTX)/ABS(X)-EPS)411,411,346
  346 IF(TOPX-BOTX-EPS)351,351,361
  351 IERR=-3
      GO TO 421
  361 IERR=-4
      GO TO 421
  411 IERR=0
  421 SOLN2=X
 5001 IF(IERR .NE. 0) WRITE(*,500) IERR,ITER
  500 FORMAT(1X,'AN ERROR SOLN2= ',I1,2X,I3)
 5002 RETURN
      END
C---------------------------------------------------------------------
C-----------------FUNCTION BOT----------------------------------------
C FINDS THE SINE OF THETA
      FUNCTION BOT(DELTA,Z,SH)
      BOT=DELTA/SQRT(DELTA*DELTA+(Z-SH)*(Z-SH))
      RETURN
      END
C---------------------------------------------------------------------
C-----------------FUNCTION ANGLE2-------------------------------------
C ANGLE2 CALCULATES THE DIFFERENCE IN DISTANCE IN KM.
C BETWEEN DELTA AND THE HORIZONTAL DISTANCE THE
C RAY TRAVELS. THE RAY LEAVES THE SOURCE AT AN ANGLE
C OF ARCSINE(X). THIS FUNCTION IS USED IN THE CASE
C OF A LATERAL DISCONTINUITY.
      FUNCTION ANGLE2(A,X,DELTA,Z,T1,V1,V2,V3)
      COMMON/THICK/TH1,TH2,TH3
      ZE=Z
      DELTA8=DELTA
      XN=X
      DA=A
      IF(Z.GE.-TH3) GO TO 28
      H=ABS(Z)-TH3
      XK=XN/SQRT(1-XN*XN)
      DA=A-H*XK
      ZE=TH3
      DELTA8=DELTA-H*XK
      XN=(3.4/5.0)*X
   28 CS1=SQRT(1-XN*XN)
      TN1=XN/CS1
      B=(ABS(ZE)-DA/TN1)/CS1
      CS2=SQRT(ABS((V1/V2)*(V1/V2)-CS1*CS1))
      B=B*CS2
      C=T1*(V3/V2)*CS2
      C=C/SQRT(ABS(1.-(V3/V2)*(V3/V2)*CS2*CS2))
      ANGLE2=DA+B+C-DELTA8
      DEL=DA+B+C-DELTA8
  466 FORMAT(1X,'ANGLE2=',F10.5,2X,F10.5,2X,F12.7)
      RETURN
      END
C---------------------------------------------------------------------
C-----------------FUNCTION TIM----------------------------------------
C THE FUNCTION TIM CALCULATES THE TRAVEL TIME
C FO THE DIRECT WAVE THROUGH A PLANE LAYERED
C LATERALLY HOMOGENOUS MEDIA.
C---------------------------------------------------------------------
      FUNCTION TIM(Z,AU,V1,V2,V3,V4,T1,T2,T3)
      COMMON/THICK/TH1,TH2,TH3
   45 FORMAT(1X,I2)
      ZE=Z
      IF(Z.GE.-TH3) GO TO 15
      ZE=ABS(Z)-TH3
   15 A=ABS(ZE)/(V1*SQRT(1-AU*AU))
      B=T1*V1/(V2*V2*SQRT((V1/V2)*(V1/V2)-AU*AU))
      D=0.
      IF(V3.LE..01) GO TO 95
      C=T2*V1/(V3*V3*SQRT((V1/V3)*(V1/V3)-AU*AU))
      IF(V4.LE..01) GO TO 98
      D=T3*V1/(V3*V3*SQRT((V1/V4)*(V1/V4)-AU*AU))
      GO TO 98
   95 C=0.
   98 TIM=A+B+C+D
      RETURN
      END
C---------------------------------------------------------------------
C-----------------FUNCTION TIM2---------------------------------------
C THE FUNCTION TIM2 CALCULATES THE TRAVEL TIME FOR
C THE DIRECT AND CRITICALLY REFRACTED WAVES IN
C A PLANE LAYERED MEDIA WITH A LATERAL DISCONTINUITY
C IN THE LAYER BETWEEN SEA LEVEL AND -TH3KM..
C---------------------------------------------------------------------
      FUNCTION TIM2(ZH,AU,DELTA,A,V1,V2,V3,T1)
      CS1=SQRT(1.-AU*AU)
      B=(ABS(ZH)-A/(AU/CS1))
      TN2=CS1/SQRT((V1/V2)*(V1/V2)-CS1*CS1)
      XL=B/TN2
      C=DELTA-A-XL
      TA=A/V1*AU
      TB=SQRT(XL*XL+B*B)/V2
      TC=SQRT(T1*T1+C*C)/V3
      TIMK=TA+TB+TC
      TIM2=TIMK
      RETURN
      END
C---------------------------------------------------------------------
C---------------FUNCTION SOLN-----------------------------------------
C SOLN SOLVES THE RAY EQUATION FOR A PATH THROUGH
C A STACK OF PLANE LAYERS BY THE METHOD OF BISECTION.
C---------------------------------------------------------------------
      FUNCTION SOLN(IND,ABOT,ATOP,EPS,IERR,DELTAQ,ZW,TH2,TH3,TH4
     &,VH1,VH2,VH3,VH4)
  805 FORMAT(1X,'SOLN ',F10.7,2X,F10.7,2X,F10.7)
      IF(EPS)11,11,21
   11 IERR=-1
      GO TO 5001
   21 X=ATOP
      TOPX=X
      MAXIT=500
      TOPY=ANGLE(X,DELTAQ,ZW,TH2,TH3,TH4,VH1,VH2,VH3,VH4)
      IF(ABS(TOPY).LE..005) GO TO 411
      IF(TOPY)31,411,31
   31 X=ABOT
      BOTX1=X
      BOTY=ANGLE(X,DELTAQ,ZW,TH2,TH3,TH4,VH1,VH2,VH3,VH4)
      IF(ABS(BOTY).LE..005) GO TO 411
      IF(BOTY)41,411,41
   41 IERR=1
      ITER=1
      DX=(TOPX-X)/4.0
   46 X=BOTX1
   51 X=X+2.0*DX
      IF(X-TOPX)61,71,71
   61 IF((ANGLE(X,DELTAQ,ZW,TH2,TH3,TH4,VH1,VH2,VH3,VH4))*TOPY)
     &201,411,51
   71 DX=DX/2.0
      GO TO (131,81),IND
   81 IF(DX/(TOPX-BOTX1)-EPS)5001,5001,46
  131 IF(DX-EPS)5001,5001,46
  201 ITER=0
      BOTX=X
      BOTY=ANGLE(X,DELTAQ,ZW,TH2,TH3,TH4,VH1,VH2,VH3,VH4)
      IF(ABS(BOTY).LE..005) GO TO 411
  211 X=(BOTX+TOPX)/2.0
      ITER=ITER+1
      IF(ITER-MAXIT)221,221,281
  221 GO TO (231,271),IND
  231 IF(TOPX-BOTX-EPS)411,411,241
  241 Y=ANGLE(X,DELTAQ,ZW,TH2,TH3,TH4,VH1,VH2,VH3,VH4)
      IF(ABS(Y).LE. .005) GO TO 411
      IF(BOTY*Y)251,411,261
  251 TOPX=X
      GO TO 211
  261 BOTX=X
      BOTY=Y
      GO TO 211
  271 IF(BOTX*TOPX)241,241,331
  281 GO TO (291,301),IND
  291 IERR=2
      GO TO 421
  301 IF(TOPX*BOTX)306,306,341
  306 IF(TOPX-BOTX-EPS)311,311,321
  311 IERR=3
      GO TO 421
  321 IERR=4
      GO TO 421
  331 IF((TOPX-BOTX)/ABS(X)-EPS)411,411,241
  341 IF((TOPX-BOTX)/ABS(X)-EPS)411,411,346
  346 IF(TOPX-BOTX-EPS)351,351,361
  351 IERR=-3
      GO TO 421
  361 IERR=-4
      GO TO 421
  411 IERR=0
  421 SOLN=X
 5001 IF(IERR .NE. 0) WRITE(*,500) IERR,ITER
  500 FORMAT(1X,'ERROR SOLN= ',I1,2X,I3)
 5002 RETURN
      END
C---------------------------------------------------------------------
C-----------------FUNCTION ANGLE--------------------------------------
C ANGLE CALCULATES THE DIFFERENCE IN DISTANCE IN
C KM. DELTA AND THE HORIZONTAL DISTACE THE RAY
C TRAVELS. THE RAY LEAVES THE SOURCE AT ANGLE DELK
C THIS FUNCTION IS OPERATIVE FOR THE
C HOMOGENOUS PLANE LAYERED CASE.
C---------------------------------------------------------------------
      FUNCTION ANGLE(XT,DELK,Z1,TA2,TA3,TA4,VA,VB,VC,VD)
  810 FORMAT(1X,'FUNCTION ANGLEh',F10.5,2X,F10.5,2X,F12.7)
      A=ABS(Z1)*XT/SQRT(1.-XT*XT)
      B=XT*TA2/SQRT(ABS((VA/VB)*(VA/VB)-XT*XT))
      C=0.
      D=0.
      IF(VC.LE..01) GO TO 150
      C=XT*TA3/SQRT(ABS((VA/VC)*(VA/VC)-XT*XT))
      IF(VD.LE..01) GO TO 150
      D=XT*TA4/SQRT(ABS((VA/VD)*(VA/VD)-XT*XT))
  150 CONTINUE
      ANGLE=A+B+C+D-DELK
      RETURN
      END
C---------------------------------------------------------------------
C------------------FUNCTION QUAD ------------------------------------
C QUAD CALCULATES THE DISTANCE BETWEEN A GRID POINT
C AND THE LATERAL VELOCITY DISCONTINIUTY ALONG A
C LINE CONNECTING A GRID POINTTO A STATION.
C THE VELOCITY DISCONTINUITY LIES AT A DISTANCE
C OF 2.22KM. FROM THE ORGIN(APPROXIMATELY THE 1000      FT.
C CONTOUR).
C DE=THE DISTANCE BETWEEN THE ORGIN AND THE GRID POINT.
C DE=THE DISTANCE BETWEEN THE ORIGIN AND THE STATION.
      FUNCTION QUAD(DH,DE,SD)
      IF(DE.LE..01) GO TO 50
      CO=DE*DE+DH*DH-SD
      CO=CO/(2.*DE*DH)
      BK=-2*DE*CO
      CK=DE*DE-4.9284
      R=SQRT(BK*BK-4.*CK)
      S1=(-BK-R)/2.
      S2=(-BK+R)/2.
      QUAD=AMAX1(S1,S2)
      GO TO 90
   50 QUAD=2.22
   90 RETURN
      END
C---------------------------------------------------------------------
C-------------FUNCTION SCOR-------------------------------------------
C FUNCTION CALCULATES STATION CORRECTION FOR UNIT THICKNESS WITH
C REFRACTION VELOCITY VB AND OVERBURDEN VELOCITY VA---
C----------------------------------------------------------------------
      FUNCTION SCOR(VA,VB)
      SCOR=(SQRT(VB*VB - VA*VA))/(VA*VB)
      RETURN
      END
C----------------------------------------------------------------------
C-------------FUNCTION CRIT-------------------------------------------
C FUNCTION CALCULATES TRAVEL TIME FOR CRITCAL REFRACTED ARRIVALS------
C---------------------------------------------------------------------
      FUNCTION CRIT(DEPTH,EL,COR1,COR2,COR3,DELTA,VR)
      COMMON/THICK/TH1,TH2,TH3
      T=(TH3-ABS(DEPTH))*COR1 +TH3*COR2 + DELTA/VR +EL*COR3
      CRIT=T
      RETURN
      END
C------TIMX-----FOR HOMOGENEOUS CASE-----------------------------------
      FUNCTION TIMX(AUD,ZL,A2,V1,V2,V3,V4,TH3,EL)
      REAL*8 ANGLE1,ANGLE2,ANGLED,ANGLE3
      ANGLE1=DASIN(AUD)
      ANGLE2=DASIN((V2/V1)*AUD)
      ANGLED=DASIN((V3/V2)*COS(ANGLE2))
      ANGLE3=DASIN((V4/V3)*COS(ANGLED))
      T1=ZL/(V1*DCOS(ANGLE1))
      T2=(A2-ZL*DTAN(ANGLE1))/(V2*DSIN(ANGLE2))
      T3=(TH3-((A2-ZL*DTAN(ANGLE1))/DTAN(ANGLE2)))*(1/DTAN(ANGLED))
     &*(1./(V3*DCOS(ANGLED)))
      T4=EL/(V4*DCOS(ANGLE3))
  90  FORMAT(1X,F8.2,2X,F8.2,2X,F8.2,2X,F8.2)
      TIMX=T1 +T2 +T3 +T4
      RETURN
      END
C----------------------------------------------------------------
C-------------------------------------------------------------------
C-------------FUNCTION CRIT INHOMOGEOUS---within thick3-------------
      FUNCTION HCRIT(V1,V2,V3,V5,DELTA,A2,EL,TH3,Z)
      STHETA1=(V3/V2)*SQRT(1.-(V2*V2)/(V1*V1))
       TERM0=STHETA1/(SQRT(1.-STHETA1*STHETA1))
       DISC5=DELTA-A2
       TERM1=TERM0*DISC5
       TERM2D=(V3*V3)/(V5*V5) -1. +STHETA1*STHETA1
       Y=EL*SQRT(1-STHETA*STHETA)/TERM2D
       TERM2=STHETA1*EL
       TERM2=TERM2/TERM2D
       C=TERM1-TERM2
       IF (C .GT. TH3) THEN
              T=99.
              GO TO 66
       ENDIF
       B=.9-C
       A=B/(SQRT((V1*V1)/(V2*V2)-1))
C--CALCULATE TRAVEL TIME--------
      DL1=A*V1/V2
      T1=DL1/V2
      DL2=C/STHETA1
      T2=DL2/V3
      DL3=SQRT(EL*EL +Y*Y)
      T3=DL3/V5
      S=TH3-Z
      STHETAC=V2/V1
      RQ=S*STHETAC/(SQRT(1-STHETAC))
      DL4=A2- A
      T4=DL4/V1
      T5=S*(SQRT(V1*V1-V2*V2)/(V1*V2))
      T=T1+T2+T3+T4+T5
   77 FORMAT(1X,6(F8.2,2X))
   66 HCRIT=T
      RETURN
      END

